// Generated by CoffeeScript 1.6.3
var Processor, defaultRules;

defaultRules = require('./processors');

Processor = (function() {
  function Processor(rules) {
    var k, rule, v, _i, _len;
    this.rules = [];
    if (rules == null) {
      rules = defaultRules;
    }
    if (Array.isArray(rules)) {
      for (_i = 0, _len = rules.length; _i < _len; _i++) {
        rule = rules[_i];
        this.addRule;
      }
    } else {
      for (k in rules) {
        v = rules[k];
        this.addRule(k, v);
      }
    }
  }

  Processor.prototype.addRule = function(ext, rule) {
    if (rule == null) {
      rule = ext;
    }
    if (rule.match == null) {
      rule.match = new RegExp("\\." + ext + "$");
    }
    return this.rules.push(rule);
  };

  Processor.prototype.findRule = function(filename) {
    var rule, _i, _len, _ref;
    _ref = this.rules;
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      rule = _ref[_i];
      if (rule.match.test(filename)) {
        return rule;
      }
    }
    return null;
  };

  Processor.prototype.process = function(filename, cb) {
    var c, cmd, cmds, rule;
    if ((rule = this.findRule(filename)) == null) {
      return cb(null, false);
    }
    if (compiler.length === 3) {
      return compiler(src, dst, cb);
    }
    cmd = compiler(src, dst);
    if (typeof cmd !== 'string') {
      return cb(null, false);
    }
    cmds = (function() {
      var _i, _len, _ref, _results;
      _ref = cmd.split(';');
      _results = [];
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        c = _ref[_i];
        if ((c != null) && c.trim() !== '') {
          _results.push(c.trim());
        }
      }
      return _results;
    })();
    return exec.quiet(cmds, function(err, stdout, stderr) {
      if (err != null) {
        return cb(err);
      }
      if ((stderr != null) && stderr.trim() !== '') {
        return cb(new Error(stderr));
      }
      return cb(null, true);
    });
  };

  return Processor;

})();

module.exports = {
  defaultRules: defaultRules,
  Processor: Processor
};

/*
//@ sourceMappingURL=processor.map
*/
