// Generated by CoffeeScript 1.6.3
var StaticServer, connect, http, middleware;

connect = require('connect');

http = require('http');

middleware = require('./middleware');

StaticServer = (function() {
  function StaticServer(opts) {
    var _ref, _ref1, _ref2;
    if (opts == null) {
      opts = {};
    }
    this.host = (_ref = opts.host) != null ? _ref : '0.0.0.0';
    this.port = (_ref1 = opts.port) != null ? _ref1 : 3000;
    this.dir = (_ref2 = opts.dir) != null ? _ref2 : process.cwd();
    this.app = connect();
    this.app.use(connect.favicon());
    this.app.use(middleware());
    this.app.use(connect.logger('dev'));
    if (opts.user && opts.pass) {
      this.app.use(connect.basicAuth(opts.user, opts.pass));
    }
    this.app.use(connect["static"](this.dir));
    this.app.use(connect.directory(this.dir, {
      hidden: true
    }));
    this.server = http.createServer(this.app);
  }

  StaticServer.prototype.run = function(cb) {
    return this.server.listen(this.port, this.host, cb);
  };

  return StaticServer;

})();

module.exports = {
  StaticServer: StaticServer
};

/*
//@ sourceMappingURL=static.map
*/
